#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h>
#include <string.h>
#include <util/delay.h>

#include "lcd_h.h"

static volatile unsigned char lcd_buffer[20];
static volatile unsigned int neco=0;
//static volatile unsigned int vzestupna=0;
static volatile unsigned int hodnota=0;
static volatile unsigned char detect=0;
static unsigned char pocitadlo=0;//33sestupnych hran (start bit a 32 datovych)
static volatile uint32_t prijate=0;
static volatile	uint16_t prijateL=0;
static volatile	uint16_t prijateH=0;
static volatile	uint32_t prijates=0;

ISR( INT1_vect )
{
if (detect == 0)
{	
TCCR1B = 0b00000010;		//start presc 8
detect = 1;
}
else
{
	prijate = prijate<<1;
	if (pocitadlo != 33)
	{
			hodnota = TCNT1;
			TCNT1 = 0;
			
				if (hodnota>26900 && hodnota<27050)		//odpovida cca 9ms+4,5ms (26900/2000000)
				//start bit
				pocitadlo++;
				if (hodnota>4000 && hodnota<4700)		//odpovida cca 2,1ms
				//log1
				{
				pocitadlo++;
				prijate |= 0x0001;

				}
				if (hodnota>1800 && hodnota<2400)		//odpovida cca 1,05ms
				//log0
				{
				pocitadlo++;
				}
			
			
	}
}
}

int main( void )
{

	MCUCR = 0b00001000;		//sestupna hrana
//vnejsi preruseni int0
	GICR = 0b10000000;	//int 1 Interrupt enable

	TCNT1 = 0;

	DDRA = 0xFF;
	DDRC = 0b00100000;			//ledka
	PORTD = 0b00001100;		//pullup int 0, 1
	PORTC = 0;
	_delay_ms(500);
	PORTC = 0b00100000;
	_delay_ms(500);
	PORTC = 0b00000000;
	_delay_ms(500);

	lcd_init();
	lcd_gotoxy(0,0);
	lcd_puts("DISPLEJ 16x2");
	sei();

while(1){

	if (pocitadlo == 33)
	{
	cli();
	TCCR1B = 0;
	pocitadlo = 0;
	detect = 0;
	prijateL = prijate & 0x0000FFFF;
	prijates = prijate & 0xFFFF0000;
	prijateH = prijates>>16;
	lcd_gotoxy(0,1);
	sprintf(lcd_buffer,"%x",prijateH);
	lcd_puts(lcd_buffer);
	sprintf(lcd_buffer,"%x",prijateL);
	lcd_puts(lcd_buffer);
	PORTC = 0b00100000;
	lcd_gotoxy(0,0);
	lcd_puts("Prijato     ");
	sei();
	}
neco++;
}


}
